// -------------------------------------------------------------------------------------
//
// CSamples.CPP                                                   Ulrich Mller 03.05.06
//                                                                PCS1700       VC++ 6.0
// Samples for using the class CFishFace in FishFace40.H/CPP
//
// -------------------------------------------------------------------------------------

#include <windows.h>
#include <iostream.h>
#include <string>
#include "..\FishFace40.h"

CFishFace ft;

void BlinkingLoop() {
	do {
		ft.SetLamp(outO1, dirOn);
		ft.Pause(555);
		ft.SetLamp(outO1, dirOff);
		ft.Pause(444);
	} while(!ft.Finish());
}

void AlternateBlinking1() {
	do {
		ft.SetLamp(outO2, dirOff);
		ft.SetLamp(outO1, dirOn);
		ft.Pause(444);
		ft.SetLamp(outO1, dirOff);
		ft.SetLamp(outO2, dirOn);
		ft.Pause(444);
	} while(!ft.Finish());
}

void AlternateBlinking2() {
	do {
		ft.SetMotors(0x1);
		ft.Pause(333);
		ft.SetMotors(0x2);
		ft.Pause(333);
	} while(!ft.Finish());
}

void TestingAnInput() {
	do {
		if(ft.GetInput(inpI1)) cout << "--- ON ---" << endl;
		else cout << "--- OFF ---" << endl;
		ft.Pause(555);
	} while(!ft.Finish(inpI5));
}

void WaitForInput() {
	cout << "For start press I1" << endl;
	ft.WaitForInput(inpI11);
	cout << "--- STARTED ---" << endl;
}

void DisplayAllInputs() {
	do { 
		for(int i = 0x80, E = ft.GetInputs(); i > 0; i >>= 1) {
			cout << ((E & i) > 0) ? "1" : "0";
		}
		cout << endl;
		ft.Pause(1234);
	} while(!ft.Finish());
}

void AnalogDisplay() {
	do{
		cout << "AX : " << ft.GetAnalog(anaAX) << " AY : " << ft.GetAnalog(anaAY) << endl;
		ft.Pause(1111);
	} while(!ft.Finish());
}

void DriveForTime() {
	ft.SetMotor(outM3, dirLeft);
	ft.Pause(3500);
	ft.SetMotor(outM3, dirOff);
	cout << "Gone for 3.5 sec" << endl;
}

void DriveToEndSwitch1() {
	ft.SetMotor(outM3, dirLeft);
	while(!ft.GetInput(inpI5));
	ft.SetMotor(outM3, dirOff);
	cout << "Switch I5 true" << endl;
}

void DriveToEndSwitch2() {
	ft.SetMotor(outM3, dirLeft);
	ft.WaitForInput(inpI5);
	ft.SetMotor(outM3, dirOff);
	cout << "Switch I5 true" << endl;
}

void DriveForStepsC() {
	ft.SetMotor(outM3, dirLeft);
	ft.WaitForChange(inpI6, 12);
	ft.SetMotor(outM3, dirOff);
}

void DriveForStepsD() {
	int ActPosition = 12;
	ft.SetMotor(outM3, dirLeft);
	ActPosition = ft.WaitForPositionDown(inpI6, ActPosition, 0, inpI5);
	ft.SetMotor(outM3, dirOff);
	cout << "ActPosition : " << ActPosition << endl;
}

void DriveForStepsU() {
	int ActPosition = 12;
	ft.SetMotor(outM3, dirRight);
	ActPosition = ft.WaitForPositionUp(inpI6, ActPosition, 24);
	ft.SetMotor(outM3, dirOff);
	cout << "ActPosition : " << ActPosition << endl;
}

void DriveForStepsW() {
	ft.SetMotor(outM3, dirLeft, speHalf, 12);
	ft.WaitForMotors(0, outM3);
	cout << "ActPosition += 12" << endl;
}

void DriveForStepsW34() {
	ft.SetMotor(outM3, dirLeft,  speFull, 121);
	ft.SetMotor(outM4, dirRight, speHalf, 64);
	do {
		cout << "Position M3 - M4 : " << ft.GetCounter(inpI6) << " - " 
			<< ft.GetCounter(inpI8) << endl;
	} while(ft.WaitForMotors(300, outM3, outM4) == waiTime);
		cout << "Position M3 - M4 : " << ft.GetCounter(inpI6) << " - " 
			<< ft.GetCounter(inpI8) << "   --- Final ---" << endl;
}

void WaitForLightBarrierBroken() {
	const int mLight = 1, ePhoto = 1;
	ft.SetMotor(mLight, dirOn);
	ft.Pause(555);
	ft.WaitForInput(ePhoto, false);
	cout << "LightBarrier M1 - E1 is broken" << endl;
}

void WaitForLightBarrierEnter() {
	const int mLight = 1, mFeeder = 3, ePhoto = 1;
	ft.SetMotor(mLight, dirOn);
	ft.Pause(555);
	ft.SetMotor(mFeeder, dirLeft);
	ft.WaitForLow(ePhoto);
	ft.SetMotor(mFeeder, dirOff);
	cout << "LightBarrier M1 - I1 is entered" << endl;
}

void WaitForLightBarrierLeave() {
	const int mLight = 1, mFeeder = 3, ePhoto = 1;
	ft.SetMotor(mLight, dirOn);
	ft.Pause(555);
	ft.SetMotor(mFeeder, dirLeft);
	ft.WaitForHigh(ePhoto);
	ft.SetMotor(mFeeder, dirOff);
	cout << "LightBarrier M1 - I1 is free" << endl;
}

void TrafficLights() {
	const int mGreen = 0x4, mYellow = 0x2, mRed = 0x01;
	while (!ft.Finish()) {
		ft.SetMotors(mGreen);
		ft.Pause(1000);
		ft.SetMotors(mYellow);
		ft.Pause(250);
		ft.SetMotors(mRed);
		ft.Pause(1000);
		ft.SetMotors(mRed + mYellow);
		ft.Pause(250);
	}
}

void TrafficLightsList() {
	const int mGreen = 0x4, mYellow = 0x2, mRed = 0x01;
	int Phase[] = {mGreen,  mGreen, mGreen, mGreen,
								 mYellow, mRed,   mRed,   mRed,   mRed,   mRed + mYellow};
	while(!ft.Finish()) {
		for(int i = 0; i <= 9; i++) {
			ft.SetMotors(Phase[i]);
			ft.Pause(500);
		}
	}
}

void RunningLights() {
	while(!ft.Finish()) {
		for(int Phase = 1; Phase < 0x10; Phase <<= 1) {
			ft.SetMotors(Phase);
			ft.Pause(555);
		}
	}
}

void main() {
	cout << "--- CSamples startet ---" <<  endl;
	cout << "To end : ESC Key" << endl;

	try {
		ft.OpenInterface(ftROBO_first_USB, 0);

		RunningLights();

	}
	catch(CFishFaceException& fte) {
		cout << "Error " << fte.Nr() << " : " << fte.Text() << endl;
	}

	while(GetAsyncKeyState(VK_ESCAPE) == 0);
	ft.CloseInterface();
}