// -------------------------------------------------------------------------------------
//
// rbSamples.CPP                                                  Ulrich Mller 03.05.06
//                                                                PCS1700       VC++ 6.0
// Tips & Trics for programming the fischertechnik Interfaces with umFish40.DLL
// Lamps on O1 and O2, Motor on M3 with end switch on I5
//
// -------------------------------------------------------------------------------------

#include <windows.h>
#include <iostream.h>
#include "..\umFish40VC.h"

const int mYellow = 1, mRed = 2, cLeft = 1, cOn = 1, cOff = 0;
int iHandle;

void BlinkingLoop() {
	do {
		rbSetLamp(iHandle, mYellow, cOn);
		Sleep(444);
		rbSetLamp(iHandle, mYellow, cOff);
		Sleep(333);
	} while(GetAsyncKeyState(VK_ESCAPE) == 0);
}

void AlternateBlinking1() {
	do {
		rbSetLamp(iHandle, mRed,    cOff);
		rbSetLamp(iHandle, mYellow, cOn);
		Sleep(333);
		rbSetLamp(iHandle, mYellow, cOff);
		rbSetLamp(iHandle, mRed,    cOn);
		Sleep(222);
	} while(GetAsyncKeyState(VK_ESCAPE) == 0);
}

void AlternateBlinking2() {
	do {
		rbSetMotors(iHandle, 0x01);
		Sleep(333);
		rbSetMotors(iHandle, 0x02);
		Sleep(222);
	} while(GetAsyncKeyState(VK_ESCAPE) == 0);
}

void DriveToEnd1() {
	rbSetMotor(iHandle, 3, cLeft);
	while(rbGetInput(iHandle, 5) == 0);
	rbSetMotor(iHandle, 3, cOff);
}

void main() {
	cout << "---- umFish40.DLL Samples started ---" << endl;
	iHandle = rbOpenInterfaceUSB(0, 0);
	cout << "Cancel with Escape Key" << endl;

	AlternateBlinking2();

	while(GetAsyncKeyState(VK_ESCAPE) == 0);
	rbCloseInterface(iHandle);
}